const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const vision_prescriptions = sequelize.define(
    'vision_prescriptions',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

prescription_date: {
        type: DataTypes.DATE,
      
      

      },

right_sphere: {
        type: DataTypes.DECIMAL,
      
      

      },

right_cylinder: {
        type: DataTypes.DECIMAL,
      
      

      },

right_axis: {
        type: DataTypes.INTEGER,
      
      

      },

left_sphere: {
        type: DataTypes.DECIMAL,
      
      

      },

left_cylinder: {
        type: DataTypes.DECIMAL,
      
      

      },

left_axis: {
        type: DataTypes.INTEGER,
      
      

      },

add_power: {
        type: DataTypes.DECIMAL,
      
      

      },

pupillary_distance_mm: {
        type: DataTypes.DECIMAL,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  vision_prescriptions.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


















































































































//end loop



    db.vision_prescriptions.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });

    db.vision_prescriptions.belongsTo(db.healthcare_providers, {
      as: 'optometrist',
      foreignKey: {
        name: 'optometristId',
      },
      constraints: false,
    });




    db.vision_prescriptions.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.vision_prescriptions.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return vision_prescriptions;
};


